#include<iostream>
#include<stdio.h>
#include<stdlib.h>
#include<algorithm>
#include<ctime>

using namespace std;


const int N=50,M=50,P=100;

struct Animal{
	int count;
	int size;

	int rows;
	int cols;
	int shape[10][10];

	int dmgFactor;
	int minSafety;
};

struct Jumper{
	int count;
	int x;
	int y;
};

int field[N+1][M+1];	
int fieldTemp[N+1][M+1];
Animal animals[P+1];
int n,m,p,numJumpers=0,tempNumJumpers;

bool sort1(const Animal &a,const Animal &b){
	return a.size*b.dmgFactor > b.size*a.dmgFactor;
}

bool sort2(const Animal &a,const Animal &b){
	return a.dmgFactor < b.dmgFactor;
}

bool sort3(const Animal &a,const Animal &b){
	return a.size >  b.size;
}
void copyField(int from[][M+1],int to[][M+1]){
	for (int i = 1; i <= n; i++){
			for (int j = 1; j <=m; j++){
				to[i][j] = from[i][j];
			}
		}
}
void init(){
	FILE *pFile;
	pFile = fopen("parash.in","r");

	if (pFile != NULL){
		fscanf(pFile,"%d%d%d",&n,&m,&p);	

		for (int i = 1; i <= n; i++){
			for (int j = 1; j <=m; j++){
				fscanf(pFile,"%d",&field[i][j]);
			}
		}

		for (int i = 1; i <= p; i++){
			animals[i].count = i;

			fscanf(pFile,"%d%d%d%d", &animals[i].rows, &animals[i].cols, &animals[i].dmgFactor, &animals[i].minSafety);

			animals[i].size = 0;
			char c[11];
			for (int j = 0; j < animals[i].rows; j++){
				fscanf(pFile,"%s",c);
				int temp = atoi(c);

				for (int k = animals[i].cols-1; k >= 0; k--){

					animals[i].shape[j][k] = temp%10;
					temp/=10;
					animals[i].size+=animals[i].shape[j][k];
				}

			}
		}

		fclose(pFile);
	}
}
void print(){
	for (int i = 1; i <= n; i++){
		for (int j = 1; j <=m; j++){
			printf("%d ",field[i][j]);
		}
		printf("\n");
	}

	for (int i = 1; i <= p; i++){

		printf("%d %d %d %d\n", animals[i].rows, animals[i].cols, animals[i].dmgFactor, animals[i].minSafety);


		for (int j = 0; j < animals[i].rows; j++){
			for (int k = 0; k < animals[i].cols; k++){
				printf("%d ",animals[i].shape[j][k]);

			}
			printf("\n");
		}
	}
}

int checkAnimal(Animal &jumper,Jumper *jumpers,int &numJumpers){
	int sum = 0;
	int maxI = 1;
	int maxJ =1;
	for (int i = 1; i <= n - jumper.rows+1; i++){
		for (int j = 1; j <= m - jumper.cols+1; j++){
			bool isOk = true;
			int tempSum = 0;
			for (int k = 0; k < jumper.rows; k++){
				for (int l = 0; l < jumper.cols; l++){
					if (jumper.shape[k][l] != 0){
						if (field[i+k][j+l] < jumper.minSafety){
							k = jumper.rows;
							isOk = false;
							break;
						}
						tempSum+=field[i+k][j+l];
					}
				}
			}

			if (isOk){
				if (sum < tempSum){
					sum = tempSum;
					maxI = i;
					maxJ = j;
				}
			}
		}
	}

	if (sum != 0) {
		jumpers[numJumpers].count = jumper.count;
		jumpers[numJumpers].x = maxI;
		jumpers[numJumpers].y = maxJ;
		numJumpers++;
		for (int i = maxI; i < maxI + jumper.rows; i++){
			for (int j = maxJ; j < maxJ + jumper.cols; j++){
				if (jumper.shape[i-maxI][j-maxJ] != 0){
					field[i][j] /= jumper.dmgFactor;
				}
			}
		}
	}
	return sum;
}

int createList(Jumper jumpers[],int &numJumpers){
	int sum=0;
	copyField(fieldTemp,field);
	for (int i = 1; i<=p; i++){
		sum += checkAnimal(animals[i],jumpers, numJumpers);
	}
	return sum;
}

void printAnswer(Jumper jumpers[], int numJumpers){
	FILE * pFile;
	pFile = fopen("parash.out","w");

	fprintf(pFile,"%d\n",numJumpers);
	for (int i = 0; i < numJumpers; i++){
		fprintf(pFile,"%d %d %d\n",jumpers[i].count,jumpers[i].x,jumpers[i].y);
	}

	fclose(pFile);
}
void findBest(Jumper jumpers[],int &numJumpers,int &maxSum){
	Jumper tempJumpers[100];
	
    clock_t timer = clock();
	int tempNumJumpers = 0;
	int tempMaxSum = 0;
	sort(animals + 1, animals + p + 1,sort2);
	tempMaxSum = createList(tempJumpers,tempNumJumpers);

	if (maxSum < tempMaxSum){
		numJumpers = tempNumJumpers;
		maxSum = tempMaxSum;
		for (int i = 0; i < numJumpers; i++){
			jumpers[i] = tempJumpers[i];
		}
	}

	tempNumJumpers = 0;
	tempMaxSum = 0;

	sort(animals + 1, animals + p + 1,sort3);
	tempMaxSum = createList(tempJumpers,tempNumJumpers);

	if (maxSum < tempMaxSum){
		numJumpers = tempNumJumpers;
		maxSum = tempMaxSum;
		for (int i = 0; i < numJumpers; i++){
			jumpers[i] = tempJumpers[i];
		}
	}
	while(((double)timer/CLOCKS_PER_SEC) < 1.9){
		tempNumJumpers = 0;
		tempMaxSum = 0;

		random_shuffle(animals+1,animals+p+1);
		tempMaxSum = createList(tempJumpers,tempNumJumpers);
		if (maxSum < tempMaxSum){
			numJumpers = tempNumJumpers;
			maxSum = tempMaxSum;
			for (int i = 0; i < numJumpers; i++){
				jumpers[i] = tempJumpers[i];
			}
		}
		timer = clock();
	}
}

int main(){
	init();
	copyField(field,fieldTemp);
	sort(animals+1,animals+p+1,sort1);
	Jumper jumpers[100];
	int numJumpers = 0;
	int maxSum;
	maxSum = createList(jumpers,numJumpers);
	findBest(jumpers,numJumpers,maxSum);
	printAnswer(jumpers,numJumpers);
	return 0;
}